package com.persagy.apm.energy.report.environment.service.impl;

import com.alibaba.fastjson.JSON;
import com.persagy.apm.common.response.PoemsFeignResponse;
import com.persagy.apm.energy.report.environment.client.EnvironmentWebClient;
import com.persagy.apm.energy.report.environment.model.dto.QueryEnvListByParamDTO;
import com.persagy.apm.energy.report.environment.model.vo.EnvAvgRateVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 环境健康feign客户端包装类
 **/
@Service
public class EnvironmentWebClientWrapper {
    @Autowired
    private EnvironmentWebClient environmentWebClient;

    /**
     * 根据条件查询环境温度达标率
     *
     * @param queryEnvListByParamDTO 查询条件
     * @return 平均达标率
     * @author wch
     * @version V1.0 2021/5/19 2:27 下午
     */
    public PoemsFeignResponse<EnvAvgRateVO> listWorkOrderByParam(QueryEnvListByParamDTO queryEnvListByParamDTO) {
        return environmentWebClient.listWorkOrderByParam(JSON.toJSONString(queryEnvListByParamDTO));
    }

}
