package com.persagy.apm.energy.report.monthly.detail.business.service;

import com.persagy.apm.energy.report.monthly.detail.business.model.*;
import com.persagy.apm.energy.report.monthly.detail.business.model.dto.*;

import java.util.List;

import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 报告详情(ReportBusinessDetail) service接口
 *
 * @author lixing
 * @version V1.0 2021-05-17 11:08:34
 */
public interface IReportBusinessDetailService {

    /**
     * 创建报告详情
     *
     * @param addReportBusinessDetailDTO addDTO
     * @return 报告详情主键
     * @author lixing
     * @version V1.0 2021-05-17 11:08:34
     */
    String createReportBusinessDetail(AddReportBusinessDetailDTO addReportBusinessDetailDTO);

    /**
     * 报告详情详情
     *
     * @param id 主键
     * @return 报告详情do对象
     * @author lixing
     * @version V1.0 2021-05-17 11:08:34
     */
    ReportBusinessDetail getReportBusinessDetail(String id);

    /**
     * 更新报告详情
     *
     * @param updateReportBusinessDetailDTO updateDTO
     * @author lixing
     * @version V1.0 2021-05-17 11:08:34
     */
    void updateReportBusinessDetail(UpdateReportBusinessDetailDTO updateReportBusinessDetailDTO);

    /**
     * 删除报告详情
     *
     * @param id 主键
     * @author lixing
     * @version V1.0 2021-05-17 11:08:34
     */
    void deleteReportBusinessDetail(String id);

    /**
     * 查询报告详情
     *
     * @param queryReportBusinessDetailDTO queryDTO
     * @return List<ReportBusinessDetail>
     * @author lixing
     * @version V1.0 2021-05-17 11:08:34
     */
    List<ReportBusinessDetail> queryReportBusinessDetailList(QueryReportBusinessDetailDTO queryReportBusinessDetailDTO);

    /**
     * 分页查询报告详情
     *
     * @param pageQueryReportBusinessDetailDTO pageQueryDTO
     * @return IPage<ReportBusinessDetail>
     * @author lixing
     * @version V1.0 2021-05-17 11:08:34
     */
    IPage<ReportBusinessDetail> pageQueryReportBusinessDetail(PageQueryReportBusinessDetailDTO pageQueryReportBusinessDetailDTO);

    /**
     * 根据段落获取报告类型关联的分组
     *
     * @param reportTypeId    报告类型
     * @param belongParagraph 报告段落
     * @return 报告段落包含的分组id列表
     * @author lixing
     * @version V1.0 2021/5/24 4:31 下午
     */
    List<String> getGroupsByParagraph(String reportTypeId, String belongParagraph);

    /**
     * 根据段落获取报告类型关联的信息点
     *
     * @param reportTypeId    报告类型
     * @param belongParagraph 报告段落
     * @return 报告段落包含的信息点id列表
     * @author lixing
     * @version V1.0 2021/5/24 4:31 下午
     */
    List<String> getFunctionsByParagraph(String reportTypeId, String belongParagraph);
}
